commit 5570ca88857188f4731b130c82ecc58944607082
Author: jklowden <jklowden>
Date:   Fri Jan 8 22:07:59 2010 +0000

    Build some utilities under Win32.  Print useful log messages for win32 connection failures.

diff --git a/ChangeLog b/ChangeLog
index fc5f130..9429ddf 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,11 @@
+Fri Jan  8 17:05:24 EST 2010	JK Lowden <jklowden@freetds.org>
+	* Nmakefile include/replacements.h win32/config.h
+	* src/apps/bsqldb.c src/apps/defncopy.c src/apps/tsql.c
+	* src/tds/config.c src/tds/hmac_md5.c src/tds/mem.c
+	* src/tds/net.c src/tds/numeric.c src/tds/token.c
+	- Build some utilities under Win32. 
+	- Print useful log messages for win32 connection failures. 	
+
 Thu Jan  7 14:56:27 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/convert_tds2sql.c: added small comments
 
@@ -2035,4 +2043,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2919 2010/01/07 13:56:55 freddy77 Exp $
+$Id: ChangeLog,v 1.2920 2010/01/08 22:07:59 jklowden Exp $
diff --git a/Nmakefile b/Nmakefile
index d003fd5..d17881b 100755
--- a/Nmakefile
+++ b/Nmakefile
@@ -1,4 +1,4 @@
-# $Id: Nmakefile,v 1.1 2009/12/22 20:58:21 jklowden Exp $
+# $Id: Nmakefile,v 1.2 2010/01/08 22:08:01 jklowden Exp $
 # Build FreeTDS and assorted utilities for Win32/Win64 without an IDE. 
 # Makefiles, unlike Visual Studio project files, are stable over time.  
 # Contributed to the public domain by James K. Lowden, February 2009
@@ -12,13 +12,17 @@
 #	nmake.exe -f Nmakefile -nologo PLATFORM=win32 CONFIGURATION=debug
 #	
 
+MKDIR = MD
+
 DBLIB_DIR        = src\dblib
 REPLACEMENTS_DIR = src\replacements
 TDS_DIR          = src\tds
+APPS_DIR         = src\apps
 
 DBLIB_OUT        = $(DBLIB_DIR)\$(PLATFORM)\$(CONFIGURATION)
 REPLACEMENTS_OUT = $(REPLACEMENTS_DIR)\$(PLATFORM)\$(CONFIGURATION)
 TDS_OUT          = $(TDS_DIR)\$(PLATFORM)\$(CONFIGURATION)
+APPS_OUT         = $(APPS_DIR)\$(PLATFORM)\$(CONFIGURATION)
 
 DBLIB_SRC = 	$(DBLIB_DIR)\bcp.c \
 		$(DBLIB_DIR)\dblib.c \
@@ -38,6 +42,7 @@ REPLACEMENTS_SRC =	$(REPLACEMENTS_DIR)\asprintf.c \
 			$(REPLACEMENTS_DIR)\basename.c \
 			$(REPLACEMENTS_DIR)\fakepoll.c \
 			$(REPLACEMENTS_DIR)\gettimeofday.c \
+			$(REPLACEMENTS_DIR)\getopt.c \
 			$(REPLACEMENTS_DIR)\iconv.c \
 			$(REPLACEMENTS_DIR)\readpassphrase.c \
 			$(REPLACEMENTS_DIR)\strlcat.c \
@@ -49,6 +54,7 @@ REPLACEMENTS_OBJ =	$(REPLACEMENTS_OUT)\asprintf.obj \
 			$(REPLACEMENTS_OUT)\basename.obj \
 			$(REPLACEMENTS_OUT)\fakepoll.obj \
 			$(REPLACEMENTS_OUT)\gettimeofday.obj \
+			$(REPLACEMENTS_OUT)\getopt.obj \
 			$(REPLACEMENTS_OUT)\iconv.obj \
 			$(REPLACEMENTS_OUT)\readpassphrase.obj \
 			$(REPLACEMENTS_OUT)\strlcat.obj \
@@ -112,7 +118,34 @@ TDS_OBJ =	$(TDS_OUT)\bulk.obj \
 		$(TDS_OUT)\vstrbuild.obj \
 		$(TDS_OUT)\write.obj 
 
-one: $(DBLIB_OUT)\db-lib.lib 
+# not yet:	$(APPS_DIR)\bsqlodbc.c 
+
+APPS_SRC =	$(APPS_DIR)\bsqldb.c \
+		$(APPS_DIR)\datacopy.c \
+		$(APPS_DIR)\defncopy.c \
+		$(APPS_DIR)\freebcp.c \
+		$(APPS_DIR)\tsql.c 
+
+APPS_OBJ =	$(APPS_OUT)\bsqldb.obj \
+		$(APPS_OUT)\datacopy.obj \
+		$(APPS_OUT)\defncopy.obj \
+		$(APPS_OUT)\freebcp.obj \
+		$(APPS_OUT)\tsql.obj 
+
+APPS_EXE =	$(APPS_OUT)\bsqldb.exe \
+		$(APPS_OUT)\datacopy.exe \
+		$(APPS_OUT)\defncopy.exe \
+		$(APPS_OUT)\freebcp.exe \
+		$(APPS_OUT)\tsql.exe 
+
+db-lib: $(DBLIB_OUT)\db-lib.lib 
+
+apps: $(DBLIB_OUT)\db-lib.lib $(APPS_EXE)
+tsql: $(APPS_OUT)\tsql.exe 
+bsqldb: $(APPS_OUT)\bsqldb.exe 
+
+##(APPS_OUT)\bsqldb.exe: $(APPS_DIR)\bsqldb.exe $(DBLIB_OUT)\db-lib.lib
+# Don't know how to create this dependency without explicitly defining every output. 
 
 #
 # Sadly the environment settings for building for different architectures
@@ -135,16 +168,33 @@ one: $(DBLIB_OUT)\db-lib.lib
 all: build-win32d build-win32r build-win64d build-win64r
 
 build-win32d: 
-	$(MAKE) -fNmakefile -nologo PLATFORM=win32 CONFIGURATION=debug
+	$(MAKE) -fNmakefile -nologo apps PLATFORM=win32 CONFIGURATION=debug
 build-win32r: 
-	$(MAKE) -fNmakefile -nologo PLATFORM=win32 CONFIGURATION=release
+	$(MAKE) -fNmakefile -nologo apps PLATFORM=win32 CONFIGURATION=release
 build-win64d: 
-	$(MAKE) -fNmakefile -nologo PLATFORM=win64 CONFIGURATION=debug
+	$(MAKE) -fNmakefile -nologo apps PLATFORM=win64 CONFIGURATION=debug
 build-win64r: 
-	$(MAKE) -fNmakefile -nologo PLATFORM=win64 CONFIGURATION=release
+	$(MAKE) -fNmakefile -nologo apps PLATFORM=win64 CONFIGURATION=release
+
+clean:
+	@if "" equ "$(PLATFORM)" 	PLATFORM not defined, see comments in Nmakefile >&2 && exit 1
+	@if "" equ "$(CONFIGURATION)" 	CONFIGURATION not defined, see comments in Nmakefile >&2 && exit 1
+	if exist $(DBLIB_OUT) 		del /q $(DBLIB_OUT)\*.obj 
+	if exist $(REPLACEMENTS_OUT) 	del /q $(REPLACEMENTS_OUT)\*.obj 
+	if exist $(TDS_OUT) 		del /q $(TDS_OUT)\*.obj 
+	if exist $(APPS_OUT) 		del /q $(APPS_OUT)\*.obj $(APPS_OUT)\*.exe
 
-$(DBLIB_OUT) $(REPLACEMENTS_OUT) $(TDS_OUT):
-	md $@
+clean-app:
+	@if "" equ "$(PLATFORM)" 	PLATFORM not defined, see comments in Nmakefile >&2 && exit 1
+	@if "" equ "$(CONFIGURATION)" 	CONFIGURATION not defined, see comments in Nmakefile >&2 && exit 1
+	if exist $(APPS_OUT) 		del /q $(APPS_OUT)\*.obj $(APPS_OUT)\*.exe
+
+# Create output directories
+$(DBLIB_OUT) $(REPLACEMENTS_OUT) $(TDS_OUT) $(APPS_OUT):
+	@echo creating output directory for configuration: "$(PLATFORM)|$(CONFIGURATION)"
+	@if "" equ "$(PLATFORM)" 	PLATFORM not defined, see comments in Nmakefile >&2 && exit 1
+	@if "" equ "$(CONFIGURATION)" 	CONFIGURATION not defined, see comments in Nmakefile >&2 && exit 1
+	$(MKDIR) $@
 
 $(DBLIB_OUT)\db-lib.lib: $(DBLIB_OUT) $(DBLIB_OBJ) $(REPLACEMENTS_OUT)\replacements.lib $(TDS_OUT)\tds.lib
 	@echo building $@ >&2
@@ -159,18 +209,20 @@ $(TDS_OUT)\tds.lib: $(TDS_OUT) $(TDS_OBJ)
 #
 # set compiler flags
 #
-INC = 	-I "include" -I "include\x64"
-FLG = 	-nologo	-W3 -Wp64 -c -EHsc -TC -Gm  -errorReport:prompt 
-DEF = 	-D "_MBCS" -D "_LIB" \
-	-D "_CRT_SECURE_NO_WARNINGS" \
+INC = 	-I "include" -I "win32" -I "include\x64" 
+FLG = 	-nologo	-W3 -Wp64 -EHsc -TC -Gm  -errorReport:prompt 
+DEF = 	-D "_MBCS" -D "_LIB" -D "WIN32" \
+	-D "_CRT_SECURE_NO_WARNINGS" -D _CRT_NONSTDC_NO_DEPRECATE \
 	-D "HAVE_CONFIG_H" \
 	-D "_FREETDS_LIBRARY_SOURCE" 
 DBG = -MTd -Od -D "_DEBUG"  -ZI -RTC1	
-REL = -MT  -O2 -D "_NDEBUG" -Zi	
+REL = -MT  -O2 -D "_NDEBUG" -Zi
+
+MSLIBS = Ws2_32.lib shell32.lib	
 
 CC = cl $(FLG) $(DEF) $(INC)
-CC32 = $(CC) -D "WIN32"	
-CC64 = $(CC) 
+CC32 = $(CC)
+CC64 = $(CC)
 
 ## Rules ##
 
@@ -179,68 +231,91 @@ CC64 = $(CC)
 #
 #c.{$(DBLIB_DIR)\win32\debug}.obj::
 {$(DBLIB_DIR)}.c{$(DBLIB_DIR)\win32\debug}.obj::
-	$(CC32) $(DBG) 	-Fo"$(DBLIB_OUT)\\" \
-			-Fd"$(DBLIB_OUT)\vc80.pdb" \
+	$(CC32) -c $(DBG) 	-Fo"$(DBLIB_OUT)\\" \
+				-Fd"$(DBLIB_OUT)\vc80.pdb" \
 	$<
 
 {$(DBLIB_DIR)\}.c{$(DBLIB_DIR)\win32\release}.obj::
-	$(CC32) $(REL) 	-Fo"$(DBLIB_OUT)\\" \
-			-Fd"$(DBLIB_OUT)\vc80.pdb" \
+	$(CC32) -c $(REL) 	-Fo"$(DBLIB_OUT)\\" \
+				-Fd"$(DBLIB_OUT)\vc80.pdb" \
 	$<
 
 {$(DBLIB_DIR)}.c{$(DBLIB_DIR)\x64\debug}.obj::
-	$(CC64) $(DBG) 	-Fo"$(DBLIB_OUT)\\" \
-			-Fd"$(DBLIB_OUT)\vc80.pdb" \
+	$(CC64) -c $(DBG) 	-Fo"$(DBLIB_OUT)\\" \
+				-Fd"$(DBLIB_OUT)\vc80.pdb" \
 	$<
 
 {$(DBLIB_DIR)}.c{$(DBLIB_DIR)\x64\release}.obj::
-	$(CC64) $(REL) 	-Fo"$(DBLIB_OUT)\\" \
-			-Fd"$(DBLIB_OUT)\vc80.pdb" \
+	$(CC64) -c $(REL) 	-Fo"$(DBLIB_OUT)\\" \
+				-Fd"$(DBLIB_OUT)\vc80.pdb" \
 	$<
 
 #
 # replacements
 #
 {$(REPLACEMENTS_DIR)}.c{$(REPLACEMENTS_DIR)\win32\debug}.obj::
-	$(CC32) $(DBG) 	-Fo"$(REPLACEMENTS_OUT)\\" \
-			-Fd"$(REPLACEMENTS_OUT)\vc80.pdb" \
+	$(CC32) -c $(DBG) 	-Fo"$(REPLACEMENTS_OUT)\\" \
+				-Fd"$(REPLACEMENTS_OUT)\vc80.pdb" \
 	$<
 
 {$(REPLACEMENTS_DIR)}.c{$(REPLACEMENTS_DIR)\win32\release}.obj::
-	$(CC32) $(REL) 	-Fo"$(REPLACEMENTS_OUT)\\" \
-			-Fd"$(REPLACEMENTS_OUT)\vc80.pdb" \
+	$(CC32) -c $(REL) 	-Fo"$(REPLACEMENTS_OUT)\\" \
+				-Fd"$(REPLACEMENTS_OUT)\vc80.pdb" \
 	$<
 
 {$(REPLACEMENTS_DIR)}.c{$(REPLACEMENTS_DIR)\x64\debug}.obj::
-	$(CC64) $(DBG) 	-Fo"$(REPLACEMENTS_OUT)\\" \
+	$(CC64) -c $(DBG) 	-Fo"$(REPLACEMENTS_OUT)\\" \
 			-Fd"$(REPLACEMENTS_OUT)\vc80.pdb" \
-	$<
+	$<		
 
 {$(REPLACEMENTS_DIR)}.c{$(REPLACEMENTS_DIR)\x64\release}.obj::
-	$(CC64) $(REL) 	-Fo"$(REPLACEMENTS_OUT)\\" \
-			-Fd"$(REPLACEMENTS_OUT)\vc80.pdb" \
+	$(CC64) -c $(REL) 	-Fo"$(REPLACEMENTS_OUT)\\" \
+				-Fd"$(REPLACEMENTS_OUT)\vc80.pdb" \
 	$<
 
 #
 # tds
 #
 {$(TDS_DIR)}.c{$(TDS_DIR)\win32\debug}.obj::
-	$(CC32) $(DBG) 	-Fo"$(TDS_OUT)\\" \
-			-Fd"$(TDS_OUT)\vc80.pdb" \
+	$(CC32) -c $(DBG) 	-Fo"$(TDS_OUT)\\" \
+				-Fd"$(TDS_OUT)\vc80.pdb" \
 	$<
 
 {$(TDS_DIR)}.c{$(TDS_DIR)\win32\release}.obj::
-	$(CC32) $(REL) 	-Fo"$(TDS_OUT)\\" \
-			-Fd"$(TDS_OUT)\vc80.pdb" \
+	$(CC32) -c $(REL) 	-Fo"$(TDS_OUT)\\" \
+				-Fd"$(TDS_OUT)\vc80.pdb" \
 	$<
 
 {$(TDS_DIR)}.c{$(TDS_DIR)\x64\debug}.obj::
-	$(CC64) $(DBG) 	-Fo"$(TDS_OUT)\\" \
-			-Fd"$(TDS_OUT)\vc80.pdb" \
+	$(CC64) -c $(DBG) 	-Fo"$(TDS_OUT)\\" \
+				-Fd"$(TDS_OUT)\vc80.pdb" \
 	$<
 
 {$(TDS_DIR)}.c{$(TDS_DIR)\x64\release}.obj::
-	$(CC64) $(REL) 	-Fo"$(TDS_OUT)\\" \
-			-Fd"$(TDS_OUT)\vc80.pdb" \
+	$(CC64) -c $(REL) 	-Fo"$(TDS_OUT)\\" \
+				-Fd"$(TDS_OUT)\vc80.pdb" \
 	$<
 
+#
+# Utilities
+#
+{$(APPS_DIR)}.c{$(APPS_DIR)\win32\debug}.exe:
+	@if not exist $(APPS_OUT) $(MKDIR) $(APPS_OUT)
+	$(CC32) $(DBG) 	-Fd"$(APPS_OUT)\vc80.pdb" -Fe$@ \
+	$< -link -LIBPATH:$(DBLIB_OUT) db-lib.lib $(MSLIBS)
+	
+{$(APPS_DIR)\}.c{$(APPS_DIR)\win32\release}.exe:
+	@if not exist $(APPS_OUT) $(MKDIR) $(APPS_OUT)
+	$(CC32) $(REL) -Fe$@ -Fd"$(APPS_OUT)\vc80.pdb" \
+	$< -link -LIBPATH:$(DBLIB_OUT) db-lib.lib $(MSLIBS)
+
+{$(APPS_DIR)}.c{$(APPS_DIR)\x64\debug}.exe:
+	@if not exist $(APPS_OUT) $(MKDIR) $(APPS_OUT)
+	$(CC64) $(DBG) -Fe$@ -Fd"$(APPS_OUT)\vc80.pdb" \
+	$< -link -LIBPATH:$(DBLIB_OUT) db-lib.lib $(MSLIBS)
+
+{$(APPS_DIR)}.c{$(APPS_DIR)\x64\release}.exe:
+	@if not exist $(APPS_OUT) $(MKDIR) $(APPS_OUT)
+	$(CC64) $(REL) -Fe$@ -Fd"$(APPS_OUT)\vc80.pdb" \
+	$< -link -LIBPATH:$(DBLIB_OUT) db-lib.lib $(MSLIBS)
+
diff --git a/include/replacements.h b/include/replacements.h
index 62ea20c..25ec0d8 100644
--- a/include/replacements.h
+++ b/include/replacements.h
@@ -20,7 +20,7 @@
 #ifndef _replacements_h_
 #define _replacements_h_
 
-/* $Id: replacements.h,v 1.20 2009/01/16 20:27:56 jklowden Exp $ */
+/* $Id: replacements.h,v 1.21 2010/01/08 22:08:01 jklowden Exp $ */
 
 #include <stdarg.h>
 #include "tds_sysdep_public.h"
@@ -97,7 +97,13 @@ char *tds_basename(char *path);
 #endif
 
 #if defined(WIN32)
+# if !defined(strncasecmp) 
+#     define  strncasecmp(x,y,z) strnicmp((x),(y),(z))
+# endif
 int gettimeofday (struct timeval *tv, void *tz);
+int getopt(int argc, char * const argv[], const char *optstring);
+extern const char *optarg;
+extern int optind, offset, opterr;
 #endif
 
 #ifdef __cplusplus
diff --git a/src/apps/bsqldb.c b/src/apps/bsqldb.c
index 630bda4..6ffc89f 100644
--- a/src/apps/bsqldb.c
+++ b/src/apps/bsqldb.c
@@ -45,9 +45,15 @@
 #include <sybdb.h>
 #include "replacements.h"
 
-static char software_version[] = "$Id: bsqldb.c,v 1.35 2009/04/18 19:35:38 jklowden Exp $";
+static char software_version[] = "$Id: bsqldb.c,v 1.36 2010/01/08 22:08:01 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
+#ifdef WIN32
+#define NULL_DEVICE "NUL:"
+#else
+#define NULL_DEVICE "/dev/null"
+#endif
+
 int err_handler(DBPROCESS * dbproc, int severity, int dberr, int oserr, char *dberrstr, char *oserrstr);
 int msg_handler(DBPROCESS * dbproc, DBINT msgno, int msgstate, int severity, char *msgtext, 
 		char *srvname, char *procname, int line);
@@ -148,7 +154,7 @@ main(int argc, char *argv[])
 	if (options.fverbose) {
 		options.verbose = stderr;
 	} else {
-		static const char null_device[] = "/dev/null";
+		static const char null_device[] = NULL_DEVICE;
 		options.verbose = fopen(null_device, "w");
 		if (options.verbose == NULL) {
 			fprintf(stderr, "%s:%d unable to open %s for verbose operation: %s\n", 
@@ -756,7 +762,7 @@ get_login(int argc, char *argv[], OPTIONS *options)
 	int ch;
 	int got_password = 0;
 
-	extern char *optarg;
+	extern const char *optarg;
 
 	assert(options && argv);
 	
diff --git a/src/apps/defncopy.c b/src/apps/defncopy.c
index 0f462ec..6f8ece3 100644
--- a/src/apps/defncopy.c
+++ b/src/apps/defncopy.c
@@ -17,6 +17,39 @@
  * Boston, MA 02111-1307, USA.
  */
 
+#ifdef MicrosoftsDbLib
+#ifdef WIN32
+# pragma warning( disable : 4142 )
+# include "win32.microsoft/have.h"
+# include "../../include/replacements.win32.hacked.h"
+# define strcasecmp(A, B) stricmp((A), (B))
+int getopt(int argc, const char *argv[], char *optstring);
+
+# ifndef DBNTWIN32
+#  define DBNTWIN32
+
+// As of Visual Studio .NET 2003, define WIN32_LEAN_AND_MEAN to avoid redefining LPCBYTE in sqlfront.h
+// Unless it was already defined, undefine it after windows.h has been included.  
+// (windows.h includes a bunch of stuff needed by sqlfront.h.  Bleh.)
+#  ifndef WIN32_LEAN_AND_MEAN
+#   define WIN32_LEAN_AND_MEAN
+#   define WIN32_LEAN_AND_MEAN_DEFINED_HERE
+#  endif
+#  include <windows.h>
+#  include <winsock2.h>
+#  ifdef WIN32_LEAN_AND_MEAN_DEFINED_HERE
+#   undef WIN32_LEAN_AND_MEAN_DEFINED_HERE
+#   undef WIN32_LEAN_AND_MEAN
+#  endif
+#  include <process.h>
+#  include <sqlfront.h>
+#  include <sqldb.h>
+
+#endif // DBNTWIN32
+# include "win32.microsoft/syb2ms.h"
+#endif
+#endif /* MicrosoftsDbLib */
+
 #if HAVE_CONFIG_H
 #include <config.h>
 #endif
@@ -46,16 +79,33 @@
 
 #include <sqlfront.h>
 #include <sybdb.h>
+#ifndef MicrosoftsDbLib
 #include "replacements.h"
+#else
+
+#ifndef WIN32
+# include "replacements.h"
+#endif
+#endif /* MicrosoftsDbLib */
 
-static char software_version[] = "$Id: defncopy.c,v 1.13 2009/01/07 02:58:47 jklowden Exp $";
+static char software_version[] = "$Id: defncopy.c,v 1.14 2010/01/08 22:08:01 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
+#ifndef MicrosoftsDbLib
 static int err_handler(DBPROCESS * dbproc, int severity, int dberr, int oserr, char *dberrstr, char *oserrstr);
 static int msg_handler(DBPROCESS * dbproc, DBINT msgno, int msgstate, int severity, char *msgtext, 
 		char *srvname, char *procname, int line);
+#else
+static int err_handler(DBPROCESS * dbproc, int severity, int dberr, int oserr, const char dberrstr[], const char oserrstr[]);
+static int msg_handler(DBPROCESS * dbproc, DBINT msgno, int msgstate, int severity, const char msgtext[], 
+		const char srvname[], const char procname[], unsigned short int line);
+#endif /* MicrosoftsDbLib */
 
+#ifndef MicrosoftsDbLib
 struct METADATA { char *name, *source, *format_string; int type, size; };
+#else
+struct METADATA { const char *name, *source, *format_string; int type, size; };
+#endif /* MicrosoftsDbLib */
 
 typedef struct _options 
 { 
@@ -83,6 +133,7 @@ static void usage(const char invoked_as[]);
 
 /* global variables */
 OPTIONS options;
+char use_statement[512];
 /* end global variables */
 
 
@@ -101,8 +152,13 @@ main(int argc, char *argv[])
 	int i, nrows;
 
 	/* Initialize db-lib */
+#if WIN32 && defined(MicrosoftsDbLib)
+	LPCSTR msg = dbinit();	
+	if (msg == NULL) {
+#else 
 	erc = dbinit();	
 	if (erc == FAIL) {
+#endif /* MicrosoftsDbLib */
 		fprintf(stderr, "%s:%d: dbinit() failed\n", options.appname, __LINE__);
 		exit(1);
 	}
@@ -120,14 +176,14 @@ main(int argc, char *argv[])
 	 * Override stdin, stdout, and stderr, as required 
 	 */
 	if (options.input_filename) {
-		if (freopen(options.input_filename, "r", stdin) == NULL) {
+		if (freopen(options.input_filename, "rb", stdin) == NULL) {
 			fprintf(stderr, "%s: unable to open %s: %s\n", options.appname, options.input_filename, strerror(errno));
 			exit(1);
 		}
 	}
 
 	if (options.output_filename) {
-		if (freopen(options.output_filename, "w", stdout) == NULL) {
+		if (freopen(options.output_filename, "wb", stdout) == NULL) {
 			fprintf(stderr, "%s: unable to open %s: %s\n", options.appname, options.output_filename, strerror(errno));
 			exit(1);
 		}
@@ -147,14 +203,19 @@ main(int argc, char *argv[])
 	 * Read the procedure names and move their texts.  
 	 */
 	for (i=options.optind; i < argc; i++) {
+#ifndef MicrosoftsDbLib
 		static const char query[] = " select	c.text"
+#else
+		static const char query[] = " select	cast(c.text as text)"
+#endif /* MicrosoftsDbLib */
+					 ", number "
 					 " from	syscomments  as c"
 					 " join 	sysobjects as o"
 					 " on 		o.id = c.id"
 					 " where	o.name = '%s'"
 					 " and 	o.uid = user_id('%s')"
 					 " and		o.type not in ('U', 'S')" /* no user or system tables */
-					 " order by 	c.colid"
+					 " order by 	c.number, c.colid"
 					;
 		static const char query_table[] = " execute sp_help '%s.%s' ";
 
@@ -181,6 +242,7 @@ main(int argc, char *argv[])
 		
 		if (0 == nrows) {
 			erc = dbfcmd(dbproc, query_table, procedure.owner, procedure.name);
+			assert(SUCCEED == erc);
 			erc = dbsqlexec(dbproc);
 			if (erc == FAIL) {
 				fprintf(stderr, "%s:%d: dbsqlexec() failed\n", options.appname, __LINE__);
@@ -315,18 +377,26 @@ print_ddl(DBPROCESS *dbproc, PROCEDURE *procedure)
 				if (p) {
 					*p = '\0'; /* we don't care where it's located */
 				}
-				/* Microsoft version: clustered, unique, primary key located on PRIMARY */
+				/* Microsoft version: [non]clustered[, unique][, primary key] located on PRIMARY */
 				p = strstr(index_description, "primary key");
 				if (p) {
 					fprimary = 1;
 					*p = '\0'; /* we don't care where it's located */
 					if ((p = strchr(index_description, ',')) != NULL) 
 						*p = '\0'; /* we use only the first term (clustered/nonclustered) */
+				} else {
+					/* reorder "unique" and "clustered" */
+					char nonclustered[] = "nonclustered", unique[] = "unique";
+					char *pclustering = nonclustered;
+					if (NULL == strstr(index_description, pclustering)) {
+						pclustering += 3;
+						if (NULL == strstr(index_description, pclustering)) 
+							*pclustering = '\0';
+					}
+					if (NULL == strstr(index_description, unique))
+						unique[0] = '\0';
+					sprintf(index_description, "%s %s", unique, pclustering);
 				}
-				while ((p = strchr(index_description, ',')) != NULL) {
-					*p = ' ';	/* and we don't need the comma */
-				}
-
 				/* Put it to a temporary file; we'll print it after the CREATE TABLE statement. */
 				if (fprimary) {
 					fprintf(create_index, "ALTER TABLE %s.%s ADD CONSTRAINT %s PRIMARY KEY %s (%s)\nGO\n\n", 
@@ -399,7 +469,11 @@ print_ddl(DBPROCESS *dbproc, PROCEDURE *procedure)
 	 * We've collected the description for the columns in the 'ddl' array.  
 	 * Now we'll print the CREATE TABLE statement in jkl's preferred format.  
 	 */
-	printf("CREATE TABLE %s.%s\n", procedure->owner, procedure->name);
+	if (nrows == 0) {
+		fclose(create_index);
+		return nrows;
+	}
+	printf("%sCREATE TABLE %s.%s\n", use_statement, procedure->owner, procedure->name);
 	for (i=0; i < nrows; i++) {
 		static const char *varytypenames[] =    { "char"  		
 							, "nchar"  		
@@ -460,15 +534,18 @@ print_ddl(DBPROCESS *dbproc, PROCEDURE *procedure)
 int /* return count of SQL text rows */
 print_results(DBPROCESS *dbproc) 
 {
-	static const char empty_string[] = "";
-	struct METADATA *metadata = NULL;
-	struct DATA { char *buffer; int status; } *data = NULL;
-	
 	RETCODE erc;
 	int row_code;
-	int c, ret;
 	int iresultset;
-	int nrows=0, ncols=0, ncomputeids;
+	int nrows=0;
+	int prior_procedure_number=1;
+	
+	/* bound variables */
+	enum column_id { ctext=1, number=2 };
+	char sql_text[8000];
+	int	 sql_text_status;
+	int	 procedure_number; /* for create proc abc;2 */
+	int	 procedure_number_status;
 	
 	/* 
 	 * Set up each result set with dbresults()
@@ -479,120 +556,54 @@ print_results(DBPROCESS *dbproc)
 			return -1;
 		}
 
-		if (SUCCEED != dbrows(dbproc)) {
+		if (SUCCEED != DBROWS(dbproc)) {
 			return 0;
 		}
 
-		/* Free prior allocations, if any. */
-		for (c=0; c < ncols; c++) {
-			free(metadata[c].format_string);
-			free(data[c].buffer);
-		}
-		free(metadata);
-		metadata = NULL;
-		free(data);
-		data = NULL;
-		ncols = 0;
-		
 		/* 
-		 * Allocate memory for metadata and bound columns 
+		 * Bind the columns to our variables.  
 		 */
-		ncols = dbnumcols(dbproc);	
-
-		metadata = (struct METADATA*) calloc(ncols, sizeof(struct METADATA));
-		assert(metadata);
-
-		data = (struct DATA*) calloc(ncols, sizeof(struct DATA));
-		assert(data);
-		
-		/* The hard-coded queries don't generate compute rows. */
-		ncomputeids = dbnumcompute(dbproc);
-		assert(0 == ncomputeids);
-
-		/* 
-		 * For each column, get its name, type, and size. 
-		 * Allocate a buffer to hold the data, and bind the buffer to the column.
-		 * "bind" here means to give db-lib the address of the buffer we want filled as each row is fetched.
-		 */
-
-		for (c=0; c < ncols; c++) {
-			int width;
-			/* Get and print the metadata.  Optional: get only what you need. */
-			char *name = dbcolname(dbproc, c+1);
-			metadata[c].name = (name)? name : (char*) empty_string;
-
-			name = dbcolsource(dbproc, c+1);
-			metadata[c].source = (name)? name : (char*) empty_string;
-
-			metadata[c].type = dbcoltype(dbproc, c+1);
-			metadata[c].size = dbcollen(dbproc, c+1);
-			assert(metadata[c].size != -1); /* -1 means indicates an out-of-range request*/
-
-#if 0
-			fprintf(stderr, "%6d  %30s  %30s  %15s  %6d  %6d  \n", 
-				c+1, metadata[c].name, metadata[c].source, dbprtype(metadata[c].type), 
-				metadata[c].size,  dbvarylen(dbproc, c+1));
-#endif 
-			/* 
-			 * Build the column header format string, based on the column width. 
-			 * This is just one solution to the question, "How wide should my columns be when I print them out?"
-			 */
-			width = get_printable_size(metadata[c].type, metadata[c].size);
-			if (width < strlen(metadata[c].name))
-				width = strlen(metadata[c].name);
-				
-			ret = set_format_string(&metadata[c], (c+1 < ncols)? "  " : "\n");
-			if (ret <= 0) {
-				fprintf(stderr, "%s:%d: asprintf(), column %d failed\n", options.appname, __LINE__, c+1);
-				return -1;
-			}
-
-			/* 
-			 * Bind the column to our variable.
-			 * We bind everything to strings, because we want db-lib to convert everything to strings for us.
-			 * If you're performing calculations on the data in your application, you'd bind the numeric data
-			 * to C integers and floats, etc. instead. 
-			 * 
-			 * It is not necessary to bind to every column returned by the query.  
-			 * Data in unbound columns are simply never copied to the user's buffers and are thus 
-			 * inaccesible to the application.  
-			 */
-
-			data[c].buffer = calloc(1, metadata[c].size);
-			assert(data[c].buffer);
-
-			erc = dbbind(dbproc, c+1, STRINGBIND, -1, (BYTE *) data[c].buffer);
-			if (erc == FAIL) {
-				fprintf(stderr, "%s:%d: dbbind(), column %d failed\n", options.appname, __LINE__, c+1);
-				return -1;
-			}
+		if (sizeof(sql_text) < dbcollen(dbproc, ctext) ) {
+			assert(sizeof(sql_text) >= dbcollen(dbproc, ctext));
+			return 0;
+		}
+		erc = dbbind(dbproc, ctext, NTBSTRINGBIND, sizeof(sql_text), (BYTE *) sql_text);
+		if (erc == FAIL) {
+			fprintf(stderr, "%s:%d: dbbind(), column %d failed\n", options.appname, __LINE__, ctext);
+			return -1;
+		}
+		erc = dbnullbind(dbproc, ctext, &sql_text_status);
+		if (erc == FAIL) {
+			fprintf(stderr, "%s:%d: dbnullbind(), column %d failed\n", options.appname, __LINE__, ctext);
+			return -1;
+		}
 
-			erc = dbnullbind(dbproc, c+1, &data[c].status);
-			if (erc == FAIL) {
-				fprintf(stderr, "%s:%d: dbnullbind(), column %d failed\n", options.appname, __LINE__, c+1);
-				return -1;
-			}
+		erc = dbbind(dbproc, number, INTBIND, -1, (BYTE *) &procedure_number);
+		if (erc == FAIL) {
+			fprintf(stderr, "%s:%d: dbbind(), column %d failed\n", options.appname, __LINE__, number);
+			return -1;
+		}
+		erc = dbnullbind(dbproc, number, &procedure_number_status);
+		if (erc == FAIL) {
+			fprintf(stderr, "%s:%d: dbnullbind(), column %d failed\n", options.appname, __LINE__, number);
+			return -1;
 		}
 
 		/* 
 		 * Print the data to stdout.  
 		 */
-		for (;(row_code = dbnextrow(dbproc)) != NO_MORE_ROWS; nrows++) {
+		fprintf(stdout, "%s", use_statement);
+		for (;(row_code = dbnextrow(dbproc)) != NO_MORE_ROWS; nrows++, prior_procedure_number = procedure_number) {
 			switch (row_code) {
 			case REG_ROW:
-				for (c=0; c < ncols; c++) {
-					switch (data[c].status) { /* handle nulls */
-					case -1: 	/* is null */
-						fprintf(stderr, "defncopy: error: unexpected NULL row in SQL text\n");
-						break;
-					case 0:	/* OK */
-					default:	/* >1 is datlen when buffer is too small */
-						fprintf(stdout, "%s", data[c].buffer);
-						break;
-					}
+				if ( -1 == sql_text_status) { 
+					fprintf(stderr, "defncopy: error: unexpected NULL row in SQL text\n");
+				} else {
+					if (prior_procedure_number != procedure_number)
+						fprintf(stdout, "\nGO\n");
+					fprintf(stdout, "%s", sql_text);
 				}
 				break;
-				
 			case BUF_FULL:
 			default:
 				fprintf(stderr, "defncopy: error: expected REG_ROW (%d), got %d instead\n", REG_ROW, row_code);
@@ -601,13 +612,17 @@ print_results(DBPROCESS *dbproc)
 			} /* row_code */
 
 		} /* wend dbnextrow */
-		fprintf(stdout, "\n");
+		fprintf(stdout, "\nGO\n");
 
 	} /* wend dbresults */
 	return nrows;
 }
 
+#ifndef MicrosoftsDbLib
 static int
+#else
+static size_t
+#endif /* MicrosoftsDbLib */
 get_printable_size(int type, int size)	/* adapted from src/dblib/dblib.c */
 {
 	switch (type) {
@@ -665,7 +680,12 @@ get_printable_size(int type, int size)	/* adapted from src/dblib/dblib.c */
 static int
 set_format_string(struct METADATA * meta, const char separator[])
 {
+#ifndef MicrosoftsDbLib
 	int width, ret;
+#else
+	size_t width;
+	int ret;
+#endif /* MicrosoftsDbLib */
 	const char *size_and_width;
 	assert(meta);
 
@@ -717,6 +737,7 @@ get_login(int argc, char *argv[], OPTIONS *options)
 {
 	LOGINREC *login;
 	int ch;
+	int fdomain = TRUE;
 
 	extern char *optarg;
 	extern int optind;
@@ -734,9 +755,7 @@ get_login(int argc, char *argv[], OPTIONS *options)
 	
 	DBSETLAPP(login, options->appname);
 	
-	if (-1 == gethostname(options->hostname, sizeof(options->hostname))) {
-		perror("unable to get hostname");
-	} else {
+	if (-1 != gethostname(options->hostname, sizeof(options->hostname))) {
 		DBSETLHOST(login, options->hostname);
 	}
 
@@ -744,9 +763,11 @@ get_login(int argc, char *argv[], OPTIONS *options)
 		switch (ch) {
 		case 'U':
 			DBSETLUSER(login, optarg);
+			fdomain = FALSE;
 			break;
 		case 'P':
 			DBSETLPWD(login, optarg);
+			fdomain = FALSE;
 			break;
 		case 'S':
 			options->servername = strdup(optarg);
@@ -776,6 +797,12 @@ get_login(int argc, char *argv[], OPTIONS *options)
 		}
 	}
 
+#ifdef MicrosoftsDbLib
+#if WIN32
+	if (fdomain) 
+		DBSETLSECURE(login);
+#endif
+#endif /* MicrosoftsDbLib */
 	if (!options->servername) {
 		usage(options->appname);
 		exit(1);
@@ -787,7 +814,11 @@ get_login(int argc, char *argv[], OPTIONS *options)
 }
 
 static int
+#ifndef MicrosoftsDbLib
 err_handler(DBPROCESS * dbproc, int severity, int dberr, int oserr, char *dberrstr, char *oserrstr)
+#else
+err_handler(DBPROCESS * dbproc, int severity, int dberr, int oserr, const char dberrstr[], const char oserrstr[])
+#endif /* MicrosoftsDbLib */
 {
 
 	if (dberr) {
@@ -804,7 +835,12 @@ err_handler(DBPROCESS * dbproc, int severity, int dberr, int oserr, char *dberrs
 }
 
 static int
+#ifndef MicrosoftsDbLib
 msg_handler(DBPROCESS * dbproc, DBINT msgno, int msgstate, int severity, char *msgtext, char *srvname, char *procname, int line)
+#else
+msg_handler(DBPROCESS * dbproc, DBINT msgno, int msgstate, int severity, const char msgtext[], 
+		const char srvname[], const char procname[], unsigned short int line)
+#endif /* MicrosoftsDbLib */
 {
 	char *dbname, *endquote; 
 
@@ -817,7 +853,7 @@ msg_handler(DBPROCESS * dbproc, DBINT msgno, int msgstate, int severity, char *m
 		if (!endquote)
 			break;
 		*endquote = '\0';
-		fprintf(stdout, "USE %s\nGO\n\n", dbname);
+		sprintf(use_statement, "USE %s\nGO\n\n", dbname);
 		return 0;		
 
 	case 0:	/* Ignore print messages */
diff --git a/src/apps/tsql.c b/src/apps/tsql.c
index e337b62..309879c 100644
--- a/src/apps/tsql.c
+++ b/src/apps/tsql.c
@@ -85,7 +85,7 @@
 #include "tdsconvert.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: tsql.c,v 1.130 2009/12/05 20:25:31 jklowden Exp $");
+TDS_RCSID(var, "$Id: tsql.c,v 1.131 2010/01/08 22:08:01 jklowden Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -385,6 +385,10 @@ get_default_instance_port(const char hostname[])
 	return tds7_get_instance_port(ip, "MSSQLSERVER");
 }
 
+#if !defined(LC_ALL)
+# define LC_ALL 0
+#endif
+
 static void
 populate_login(TDSLOGIN * login, int argc, char **argv)
 {
diff --git a/src/tds/config.c b/src/tds/config.c
index 6610c5f..0d8b661 100644
--- a/src/tds/config.c
+++ b/src/tds/config.c
@@ -76,7 +76,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: config.c,v 1.151 2009/11/26 09:47:41 freddy77 Exp $");
+TDS_RCSID(var, "$Id: config.c,v 1.152 2010/01/08 22:08:01 jklowden Exp $");
 
 static void tds_config_login(TDSCONNECTION * connection, TDSLOGIN * login);
 static void tds_config_env_tdsdump(TDSCONNECTION * connection);
@@ -271,18 +271,22 @@ tds_try_conf_file(const char *path, const char *how, const char *server, TDSCONN
 	int found = 0;
 	FILE *in;
 
-	if ((in = fopen(path, "r")) != NULL) {
-		tdsdump_log(TDS_DBG_INFO1, "Found conf file '%s' %s.\n", path, how);
-		found = tds_read_conf_sections(in, server, connection);
+	if ((in = fopen(path, "r")) == NULL) {
+		tdsdump_log(TDS_DBG_INFO1, "Could not open '%s' (%s).\n", path, how);
+		return found;
+	}
 
-		if (found) {
-			tdsdump_log(TDS_DBG_INFO1, "Success: [%s] defined in %s.\n", server, path);
-		} else {
-			tdsdump_log(TDS_DBG_INFO2, "[%s] not found.\n", server);
-		}
+	tdsdump_log(TDS_DBG_INFO1, "Found conf file '%s' %s.\n", path, how);
+	found = tds_read_conf_sections(in, server, connection);
 
-		fclose(in);
+	if (found) {
+		tdsdump_log(TDS_DBG_INFO1, "Success: [%s] defined in %s.\n", server, path);
+	} else {
+		tdsdump_log(TDS_DBG_INFO2, "[%s] not found.\n", server);
 	}
+
+	fclose(in);
+
 	return found;
 }
 
diff --git a/src/tds/hmac_md5.c b/src/tds/hmac_md5.c
index f6e86e5..a08929f 100644
--- a/src/tds/hmac_md5.c
+++ b/src/tds/hmac_md5.c
@@ -17,7 +17,11 @@
  * Boston, MA 02111-1307, USA.
  */
 
-/* $Id: hmac_md5.c,v 1.1 2008/07/30 08:02:55 freddy77 Exp $ */
+/* $Id: hmac_md5.c,v 1.2 2010/01/08 22:08:01 jklowden Exp $ */
+
+#if HAVE_CONFIG_H
+#include <config.h>
+#endif /* HAVE_CONFIG_H */
 
 #include "tds.h"
 #include "md5.h"
diff --git a/src/tds/mem.c b/src/tds/mem.c
index 43987a4..682816b 100644
--- a/src/tds/mem.c
+++ b/src/tds/mem.c
@@ -41,7 +41,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: mem.c,v 1.193 2009/11/26 09:47:41 freddy77 Exp $");
+TDS_RCSID(var, "$Id: mem.c,v 1.194 2010/01/08 22:08:01 jklowden Exp $");
 
 static void tds_free_env(TDSSOCKET * tds);
 static void tds_free_compute_results(TDSSOCKET * tds);
@@ -630,12 +630,12 @@ winsock_initialized(void)
 		return 1;
 
 	if (WSANOTINITIALISED != (erc = WSAGetLastError())) {
-		fprintf(stderr, "tds_init_winsock: WSAEnumProtocols failed with %d(%s)\n", erc, tds_prwsaerror(erc) ); 
+		fprintf(stderr, "tds_init_winsock: WSAEnumProtocols failed with %d (%s)\n", erc, tds_prwsaerror(erc) ); 
 		return 0;
 	}
 	
 	if (SOCKET_ERROR == (erc = WSAStartup(requested_version, &wsa_data))) {
-		fprintf(stderr, "tds_init_winsock: WSAStartup failed with %d(%s)\n", erc, tds_prwsaerror(erc) ); 
+		fprintf(stderr, "tds_init_winsock: WSAStartup failed with %d (%s)\n", erc, tds_prwsaerror(erc) ); 
 		return 0;
 	}
 #endif
